/*
	JkMemoWrite.h

	Author	: Kang Jul Ki (Master 2nd)
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: April 6, 2000
	Class	: Software Engineering Lab
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: Visual C++ 6.0 & gcc 2.7.2
	Tab Size: 8
	
	Copyright (c) 2000, Kang Jul Ki
*/

#ifndef __JkMemoWrite_h_
#define __JkMemoWrite_h_

#include "qDecoder.h"
#include "JkMemo.h"
#include "JkMemoMain.h"
#include <time.h>
#include <string.h>

/**
 * This class is used for Main Routine.
 */
class JkMemoWrite
{
	JkMemoMain*	m_pJkMemoMain;
	DbArticle*	m_pDbArticle;

public:
	JkMemoWrite	(JkMemoMain* pJkMemoMain);
	~JkMemoWrite	();

	void	WriteSave	();
	void	AdminLogin	();
	void	AdminForm	();
	void	AdminSave	();

	void	RemoveForm	();
	void	RemoveSave	();

	void	Run		();
};

#endif	// __JkMemoWrite_h_


