#define TRUE		(1)
#define FALSE		(0)

#define FNAME		(1)      /* ̸ ϸ */
#define FSUBJECT	(2)      /*  */
#define FTEXT		(4)      /*  */

#define OFFICIAL_PROGRAM_NAME		"CrazyWWWBoard"
#define OFFICIAL_CGI_NAME		"CrazyWWWBoard.cgi"
#define OFFICIAL_PROGRAM_VERSION	"98 Professional Edition"
#define REALTIME_CONFIG_FILE		"CrazyWWWBoard.conf"

#define TYPE_UNLINK	(0)
#define TYPE_LINK	(1)
#define TYPE_TEXT	(2)
#define TYPE_IMAGE	(3)
#define TYPE_SOUND	(4)
#define TYPE_MOVIE	(5)

#define MAX_PASSWORD_LEN	(8)

typedef struct {
  char *db;
  char *mode;
  int  page;
  int  num;
  char *password;

  int  ftype;   /* 3 And ó ȴ, ̸:00000001, :00000010, :00000100 */
  char *fval;
  char *fencval; /* Encoding fval, Link */

  int  backdepth; /*  back  ؼ Ѵ.  back  Ʈ ü ֵ */

  char *date; /*  ⿡ Ǵ ¥ Ʈ YYYYMMDD */
}DB;

typedef struct {
  char *ProgramName;

  char *RealBasePath;
  char *HtmlBasePath;

  char *DefaultTitle;
  char *DefaultCharSet;

  char *UploadSoftLimit;
  char *UploadHardLimit;

  char *DataDirectory;
  char *DataExtension;

  char *LogDirectory;

  char *HtmlHead;
  char *HtmlTail;

  char *Help;

  char *IconAdmin;
  char *IconStat;
  char *IconHome;
  char *IconBack;
  char *IconHelp;

  char *IconList;
  char *IconReload;
  char *IconWrite;
  char *IconModify;
  char *IconReply;
  char *IconDelete;

  char *IconUp;
  char *IconDown;

  char *IconBlank;

  char *IconWidth;
  char *IconHeight;

  char *IconOpen;
  char *IconClose;
  char *IconOpenNew;
  char *IconCloseNew;
  char *IconTypeDefault;
  char *IconTypeUnknown;

  char *StatBarWidth;
  char *StatBarMaxHeight;

  char *StatBarUnder;
  char *StatBar90;
  char *StatBar80;
  char *StatBar70;
  char *StatBar60;
  char *StatBar50;
  char *StatBar40;
  char *StatBar30;
  char *StatBar20;
  char *StatBar10;
  char *StatBar00;

  char *CryptSalt;

  char *SendmailDirectory;
  char *SendmailFilename;
  char *SendmailOptions;

  char *MailHead;
  char *MailTail;

  char *MailName;
  char *MailOrganization;

  char *CookieEnable;
  char *CookieExpireDays;

  char *PageLinkNum;

  char *TextFieldLength;

  char *ReSubject;
  char *ReText;
  char *ReLine;

  char *PreviewLines;

  char *HiddenAdminLink;
  char *HiddenStatLink;
  char *HiddenHelpLink;

  char *AllowDBhtml;
  char *AllowDBmail;
  char *AllowUpload;
}SysConfig;

typedef struct {
  int  LastNum;

  char *Password;
  char *Title;
  char *Message;

  char *HomeUrl;
  char *HomeTarget;
  char *BackUrl;
  char *BackTarget;

  char *AdminName;
  char *AdminEmail;
  char *MailToAdmin;
  char *MailToSender;

  char *Language;
  char *CharSet;
  char *ListOrder;
  char *UnderlinedLink;
  char *NameFirst;
  char *ArticleNumber;
  char *VirtualNumber;
  char *FolderIcon;
  char *DisplayAddress;
  char *UploadEnable;
  char *TypeIcon;
  char *LinkTarget;
  char *WriteMode;
  char *HtmlAccept;
  char *HideSearch;
  char *HighLightArticle;
  int  ArticlesPerPage;

  char *FontSize;
  char *TableWidth;
  char *UseSysDefHtml;
  char *HtmlHead;
  char *HtmlTail;

  char *ListBorderSize;
  char *Nobr;
  char *ListTitleFontColor;
  char *ListTitleBgColor;
  char *ListArticleFontColor;
  char *ListArticleBgColor;

  char *ReadTitleBorderSize;
  char *ReadTextBorderSize;
  char *ReadTitleFontColor;
  char *ReadTitleBgColor;
  char *ReadTextFontColor;
  char *ReadTextBgColor;

  char *WriteTitleFontColor;
  char *WriteTitleBgColor;
  char *DefaultSubject;
  char *DefaultText;

  char *UseSysDefMail;
  char *MailHead;
  char *MailTail;
}DBConfig;

typedef struct {
  /* Article Info or ӽ */  
  int  Num;
  int  Year, Mon, Day, Hour, Min, Sec;

  /*  DB Ǵ Article Skeleton Full Field */
  char *Name;
  char *Email;
  char *Subject;
  char *Text;

  char *Filename;
  char *Filesize;

  char *Date;
  char *IP;
  char *Domain;

  int  Lines;
  int  Access;
  int  Thread;

  char *Password;
}DBArticle;

/*** Ϻ ⿡ ϴ  Article Skeleton ***/
typedef struct {
  int  Num;
  int  Year, Mon, Day;
  int  DaysAgo; /* Խù 糯¥    ԽõǾ ȴ */

  /* DB  */
  char *Name;
  char *Email;
  char *Subject;

  char *Filename;
  char *Filesize;

  char *Date;
  int  Lines;
  int  Access;
}DBList;

/***   ü ***/
typedef struct {
  int sYear, sMon, sDay; /* α    */
  int eYear, eMon, eDay; /* α    */
  int Year,  Mon,  Day[31+1], Max, Total, Avg;
  int TotalAccess;
}Stat;

/* common user functions */
void headHtml(SysConfig *sys, DBConfig *conf);
void tailHtml(SysConfig *sys, DBConfig *conf);
char *exchangeQuot(char *str);

/* common system functions */
char *crypt(const char *, const char *);
FILE *popen(const char *, const char *);
int  pclose(FILE *);
